//Includes:
#include <sourcemod>
#include <sdktools>

#define PLUGIN_VERSION "1.0"
#define DF_CRITS		1048576	//crits = DAMAGE_BULLET


#define HITGROUP_GENERIC   0
#define HITGROUP_HEAD      1
#define HITGROUP_CHEST     2
#define HITGROUP_STOMACH   3
#define HITGROUP_LEFTARM   4
#define HITGROUP_RIGHTARM  5
#define HITGROUP_LEFTLEG   6
#define HITGROUP_RIGHTLEG  7

new Handle:bt_enable;
new Handle:bt_timescale;
new Handle:bt_trans;
new Handle:bt_fsound;

new slowdown = 0;
new focussound = 2;
new transition = false;
new Float:timescale = 0.50;

new Handle:Cheats = INVALID_HANDLE;

static const String:Weapons[][]={"spade", "amerknife","bazooka", "pschreck"};	


public Plugin:myinfo = 

{
	name = "DOD Bullet Time",
	author = "Andi67",
	description = "Creates a slow-motion effect on events in bullet time / matrix style",
	version = PLUGIN_VERSION,
	url = "http://www.dodsourceplugins.net/"
};

public OnPluginStart() 
{
	CreateConVar("dod_bullettime_version", PLUGIN_VERSION, "SM Bullet Time Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	bt_enable = CreateConVar("bt_enable", "1", "Enables/Disables Bullet Time.", FCVAR_PLUGIN);
	bt_trans = CreateConVar("bt_transition", "1", "Transitions the timescales if on. If not, timescales are set directly.", FCVAR_PLUGIN);
	bt_timescale = CreateConVar("bt_timescale", "0.50", "Slowdown timescale.", FCVAR_PLUGIN);
	bt_fsound = CreateConVar("bt_fsound", "2", "Plays a sound for the focus of bullet time. If 2 it replaces the default sound rather than playing simultaneously.", FCVAR_PLUGIN);
	HookEvent("player_hurt", EventPlayerHurt);
	HookConVarChange(bt_trans, OnConVarChanged_Trans);
	timescale = GetConVarFloat(bt_timescale);
	transition = GetConVarBool(bt_trans);
	focussound = GetConVarBool(bt_fsound);
	Cheats = FindConVar("sv_cheats");
}

public OnConfigsExecuted() 
{
    AddFileToDownloadsTable("materials/imgay/slowdown1.vmt");
    AddFileToDownloadsTable("materials/imgay/slowdown2.vmt");
    AddFileToDownloadsTable("materials/imgay/slowdown3.vmt");
    AddFileToDownloadsTable("materials/imgay/slowdown1.vtf");
    AddFileToDownloadsTable("materials/imgay/slowdown2.vtf");
    AddFileToDownloadsTable("materials/imgay/slowdown3.vtf");
}

public OnMapStart()
{
	PrecacheSound("imgay/nmh_slash_low.mp3", true);
	PrecacheSound("imgay/nmh_kill.mp3", true);
	AddFileToDownloadsTable("sound/imgay/nmh_slash_low.mp3");
	AddFileToDownloadsTable("sound/imgay/nmh_kill.mp3");
	
	CheatConVarSetup()
} 

ActivateSlow(activator) 
{
    if (slowdown > 0 || !GetConVarBool(bt_enable))
        return;
    slowdown = 55;
    for(new i = 1; i <= MaxClients; i++) 
	{
        if(IsValidClient(i) && !IsFakeClient(i)) 
		{
            ClientCommand(i,"r_screenoverlay imgay/slowdown1");
            if (i != activator) 
			{
                EmitSoundToClient(i, "imgay/nmh_slash_low.mp3");
            }
        }
    }
    timescale = GetConVarFloat(bt_timescale);
    ServerCommand("host_timescale %f", timescale);
}

public OnGameFrame() 
{
	if (transition && slowdown <= 10 && slowdown > 1)
	{
		timescale = GetConVarFloat(bt_timescale);
		new Float:difscale = 1.0 - timescale;
		new Float:tempscale = 1.0 - difscale * slowdown *0.1;
		ServerCommand("host_timescale %f", tempscale);
	}

	if (slowdown == 5)
	{
		for(new i = 1; i <= MaxClients; i++)
		{
			if(IsValidClient(i) && !IsFakeClient(i)) 
			{
				ClientCommand(i,"r_screenoverlay imgay/slowdown2");
			}
		}   
	}
    
	if (slowdown == 3)
	{
		for(new i = 1; i <= MaxClients; i++)
		{
			if(IsValidClient(i) && !IsFakeClient(i))
			{
				ClientCommand(i,"r_screenoverlay imgay/slowdown3");
			}
		}   
	}
	if (slowdown == 1)
	{
		slowdown = slowdown - 1;
		ServerCommand("host_timescale 1.0")
		SetConVarInt(Cheats, 0, true, true)
		for(new i = 1; i <= MaxClients; i++) 
		{
			if(IsValidClient(i) && !IsFakeClient(i)) 
			{
				ClientCommand(i,"r_screenoverlay \"\"")
			}
		}
	}
	if (slowdown > 1)
	{
		slowdown = slowdown - 1;
	}
}

public OnConVarChanged_Trans(Handle:convar, const String:oldValue[], const String:newValue[]) 
{
	transition = GetConVarBool(bt_trans);
}

public EventPlayerHurt(Handle:event, const String:name[], bool:dontBroadcast) 
{
	// "userid"        "short"         // user ID who was hurt
	// "attacker"      "short"         // user ID who attacked
	// "weapon"        "string"        // weapon name attacker used
	// "health"        "byte"          // health remaining
	// "damage"        "byte"          // how much damage in this attack
	// "hitgroup"      "byte"          // what hitgroup was hit	
	
	if (!GetConVarBool(bt_enable))
		return;
	decl String:weapon[512];
	GetEventString(event, "weapon", weapon, sizeof(weapon));
	new g_damage = GetEventInt(event, "health");
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
    
	new bool:go = false;
	new activator = -1;
	for (new i = 0; i < sizeof(Weapons); i++) 
	{
		if (StrEqual(weapon,Weapons[i],false)) 
		{	
			go = true;
		}
		
		if ((g_damage & DF_CRITS)) 
		{
			go = true;
		}
		
		focussound = GetConVarBool(bt_fsound);
		if (go == true && focussound >= 1) 
		{
			if(IsValidClient(attacker) && !IsFakeClient(attacker)) 
			{
				EmitSoundToClient(attacker, "imgay/nmh_kill.mp3");
				if (focussound >= 2) activator = attacker;
			}
			ActivateSlow(activator);
			SetConVarInt(Cheats, 1, true, true);
		}
    }
}

stock bool:IsValidClient(iClient)
{
    if (iClient <= 0) return false;
    if (iClient > MaxClients) return false;
    if (!IsClientConnected(iClient)) return false;
    return IsClientInGame(iClient);
}

public CheatConVarSetup()
{
	new flags = GetConVarFlags(Cheats) 
	flags &= ~FCVAR_NOTIFY
	SetConVarFlags(Cheats, flags)
	if(GetConVarInt(Cheats) == 1)
	{
		SetConVarInt(Cheats, 0, true, true)
	}
}